Index: code/trunk/src/libraries/core/BaseObject.cc
===================================================================
--- code/trunk/src/libraries/core/BaseObject.cc	(revision 7278)
+++ code/trunk/src/libraries/core/BaseObject.cc	(revision 7284)
@@ -39,5 +39,4 @@
 #include "Event.h"
 #include "EventIncludes.h"
-#include "Functor.h"
 #include "Iterator.h"
 #include "Template.h"
@@ -45,4 +44,5 @@
 #include "XMLNameListener.h"
 #include "XMLPort.h"
+#include "command/Functor.h"
 
 namespace orxonox
@@ -477,6 +477,6 @@
                 if (!container)
                 {
-                    ExecutorMember<BaseObject>* setfunctor = createExecutor(createFunctor(&BaseObject::addEventSource), std::string( "BaseObject" ) + "::" + "addEventSource" + '(' + statename + ')');
-                    ExecutorMember<BaseObject>* getfunctor = createExecutor(createFunctor(&BaseObject::getEventSource), std::string( "BaseObject" ) + "::" + "getEventSource" + '(' + statename + ')');
+                    const ExecutorMemberPtr<BaseObject>& setfunctor = createExecutor(createFunctor(&BaseObject::addEventSource), std::string( "BaseObject" ) + "::" + "addEventSource" + '(' + statename + ')');
+                    const ExecutorMemberPtr<BaseObject>& getfunctor = createExecutor(createFunctor(&BaseObject::getEventSource), std::string( "BaseObject" ) + "::" + "getEventSource" + '(' + statename + ')');
                     setfunctor->setDefaultValue(1, statename);
                     getfunctor->setDefaultValue(1, statename);
Index: code/trunk/src/libraries/core/BaseObject.h
===================================================================
--- code/trunk/src/libraries/core/BaseObject.h	(revision 7278)
+++ code/trunk/src/libraries/core/BaseObject.h	(revision 7284)
@@ -196,5 +196,5 @@
             mbool                   bVisible_;                 //!< True = the object is visible
             std::string             mainStateName_;
-            Functor*                mainStateFunctor_;
+            FunctorPtr              mainStateFunctor_;
             std::set<std::string>   networkTemplateNames_;
 
Index: code/trunk/src/libraries/core/CMakeLists.txt
===================================================================
--- code/trunk/src/libraries/core/CMakeLists.txt	(revision 7278)
+++ code/trunk/src/libraries/core/CMakeLists.txt	(revision 7284)
@@ -19,4 +19,5 @@
 
 SET_SOURCE_FILES(CORE_SRC_FILES
+  CommandLineParser.cc
   ConfigValueContainer.cc
   Core.cc
@@ -29,5 +30,4 @@
   GraphicsManager.cc
   GUIManager.cc
-  IOConsole.cc
   Language.cc
   LuaState.cc
@@ -35,14 +35,5 @@
   OrxonoxClass.cc
   Resource.cc
-  ScopedSingletonManager.cc
   WindowEventListener.cc
-
-  # command
-  CommandEvaluation.cc
-  CommandExecutor.cc
-  CommandLineParser.cc
-  ConsoleCommand.cc
-  ConsoleCommandCompilation.cc
-  Executor.cc
 
   # hierarchy
@@ -60,11 +51,6 @@
   XMLNameListener.cc
 
-  # shell
-  IRC.cc
-  Shell.cc
-  TclBind.cc
-
 COMPILATION_BEGIN FilesystemCompilation.cc
-  ArgumentCompletionFunctions.cc
+  command/ArgumentCompletionFunctions.cc
   ConfigFileManager.cc
   MemoryArchive.cc
@@ -75,9 +61,10 @@
   ThreadPool.cc
 COMPILATION_BEGIN ThreadCompilation.cc
-  TclThreadManager.cc
+  command/TclThreadManager.cc
   Thread.cc
 COMPILATION_END
 )
 
+ADD_SUBDIRECTORY(command)
 ADD_SUBDIRECTORY(input)
 
@@ -85,5 +72,5 @@
   FIND_HEADER_FILES
   TOLUA_FILES
-    CommandExecutor.h
+    command/CommandExecutor.h
     ConfigFileManager.h
     Game.h
Index: code/trunk/src/libraries/core/CommandLineParser.cc
===================================================================
--- code/trunk/src/libraries/core/CommandLineParser.cc	(revision 7278)
+++ code/trunk/src/libraries/core/CommandLineParser.cc	(revision 7284)
@@ -335,5 +335,5 @@
     {
         std::vector<std::string> args;
-        SubString tokens(cmdLine, " ", " ", false, '\\', true, '"', true, '(', ')', false);
+        SubString tokens(cmdLine, " ", " ", false, '\\', true, '"', true, '\0', '\0', false);
         for (unsigned i = 0; i < tokens.size(); ++i)
             args.push_back(tokens[i]);
@@ -363,5 +363,5 @@
                 //if (!(line[0] == '#' || line[0] == '%'))
                 //{
-                SubString tokens(line, " ", " ", false, '\\', true, '"', true, '(', ')', false, '#');
+                SubString tokens(line, " ", " ", false, '\\', true, '"', true, '\0', '\0', false, '#');
                 for (unsigned i = 0; i < tokens.size(); ++i)
                     if (tokens[i][0] != '#')
Index: code/trunk/src/libraries/core/CommandLineParser.h
===================================================================
--- code/trunk/src/libraries/core/CommandLineParser.h	(revision 7278)
+++ code/trunk/src/libraries/core/CommandLineParser.h	(revision 7284)
@@ -64,5 +64,5 @@
         Note the difference between "-" and "--"!
         Also, there is no restriction to the number of strings you add after --name.
-        So "--startVector (2, 4, 5)" is perfectly legal.
+        So "--startVector {2, 4, 5}" is perfectly legal.
 
         Retrieving an argument is possible with the getCommandLineArgument function of the
Index: code/trunk/src/libraries/core/ConfigFileManager.cc
===================================================================
--- code/trunk/src/libraries/core/ConfigFileManager.cc	(revision 7278)
+++ code/trunk/src/libraries/core/ConfigFileManager.cc	(revision 7284)
@@ -34,7 +34,7 @@
 #include "util/Math.h"
 #include "util/StringUtils.h"
-#include "ConsoleCommand.h"
 #include "ConfigValueContainer.h"
 #include "PathConfig.h"
+#include "command/ConsoleCommand.h"
 
 namespace orxonox
@@ -277,11 +277,14 @@
                             if (commentposition == std::string::npos)
                             {
-                                value = removeTrailingWhitespaces(line.substr(pos1 + 1));
+                                value = line.substr(pos1 + 1);
                             }
                             else
                             {
-                                value = removeTrailingWhitespaces(line.substr(pos1 + 1, commentposition - pos1 - 1));
+                                value = line.substr(pos1 + 1, commentposition - pos1 - 1);
                                 comment = removeTrailingWhitespaces(line.substr(commentposition));
                             }
+
+                            value = removeTrailingWhitespaces(value);
+                            value = removeSlashes(value);
 
                             if (pos2 != std::string::npos && pos3 != std::string::npos && pos3 > pos2 + 1)
@@ -425,4 +428,16 @@
     ////////////////////////
 
+    static const std::string __CC_load_name = "reloadSettings";
+    static const std::string __CC_setFilename_name = "setSettingsFile";
+    static const std::string __CC_config_name = "config";
+    static const std::string __CC_tconfig_name = "tconfig";
+    static const std::string __CC_getConfig_name = "getConfig";
+
+    SetConsoleCommand(__CC_load_name,            &ConfigFile::load);
+    SetConsoleCommand(__CC_setFilename_name,     &SettingsConfigFile::setFilename);
+    SetConsoleCommand(__CC_config_name,          &SettingsConfigFile::config).argumentCompleter(0, autocompletion::settingssections()).argumentCompleter(1, autocompletion::settingsentries()).argumentCompleter(2, autocompletion::settingsvalue());
+    SetConsoleCommand(__CC_tconfig_name,         &SettingsConfigFile::tconfig).argumentCompleter(0, autocompletion::settingssections()).argumentCompleter(1, autocompletion::settingsentries()).argumentCompleter(2, autocompletion::settingsvalue());
+    SetConsoleCommand(__CC_getConfig_name,       &SettingsConfigFile::getConfig).argumentCompleter(0, autocompletion::settingssections()).argumentCompleter(1, autocompletion::settingsentries());
+
     SettingsConfigFile* SettingsConfigFile::singletonPtr_s = 0;
 
@@ -430,18 +445,18 @@
         : ConfigFile(filename)
     {
-        ConsoleCommand* command = createConsoleCommand(createFunctor(&ConfigFile::load, this), "reloadSettings");
-        CommandExecutor::addConsoleCommandShortcut(command);
-        command = createConsoleCommand(createFunctor(&SettingsConfigFile::setFilename, this), "setSettingsFile");
-        CommandExecutor::addConsoleCommandShortcut(command);
-        command = createConsoleCommand(createFunctor(&SettingsConfigFile::config, this), "config");
-        CommandExecutor::addConsoleCommandShortcut(command).argumentCompleter(0, autocompletion::settingssections()).argumentCompleter(1, autocompletion::settingsentries()).argumentCompleter(2, autocompletion::settingsvalue());
-        command = createConsoleCommand(createFunctor(&SettingsConfigFile::tconfig, this), "tconfig");
-        CommandExecutor::addConsoleCommandShortcut(command).argumentCompleter(0, autocompletion::settingssections()).argumentCompleter(1, autocompletion::settingsentries()).argumentCompleter(2, autocompletion::settingsvalue());
-        command = createConsoleCommand(createFunctor(&SettingsConfigFile::getConfig, this), "getConfig");
-        CommandExecutor::addConsoleCommandShortcut(command).argumentCompleter(0, autocompletion::settingssections()).argumentCompleter(1, autocompletion::settingsentries());
+        ModifyConsoleCommand(__CC_load_name).setObject(this);
+        ModifyConsoleCommand(__CC_setFilename_name).setObject(this);
+        ModifyConsoleCommand(__CC_config_name).setObject(this);
+        ModifyConsoleCommand(__CC_tconfig_name).setObject(this);
+        ModifyConsoleCommand(__CC_getConfig_name).setObject(this);
     }
 
     SettingsConfigFile::~SettingsConfigFile()
     {
+        ModifyConsoleCommand(__CC_load_name).setObject(0);
+        ModifyConsoleCommand(__CC_setFilename_name).setObject(0);
+        ModifyConsoleCommand(__CC_config_name).setObject(0);
+        ModifyConsoleCommand(__CC_tconfig_name).setObject(0);
+        ModifyConsoleCommand(__CC_getConfig_name).setObject(0);
     }
 
@@ -543,12 +558,14 @@
     }
 
-    bool SettingsConfigFile::config(const std::string& section, const std::string& entry, const std::string& value)
-    {
-        return this->configImpl(section, entry, value, &ConfigValueContainer::set);
-    }
-
-    bool SettingsConfigFile::tconfig(const std::string& section, const std::string& entry, const std::string& value)
-    {
-        return this->configImpl(section, entry, value, &ConfigValueContainer::tset);
+    void SettingsConfigFile::config(const std::string& section, const std::string& entry, const std::string& value)
+    {
+        if (!this->configImpl(section, entry, value, &ConfigValueContainer::set))
+            COUT(1) << "Error: Config value \"" << entry << "\" in section \"" << section << "\" doesn't exist." << std::endl;
+    }
+
+    void SettingsConfigFile::tconfig(const std::string& section, const std::string& entry, const std::string& value)
+    {
+        if (!this->configImpl(section, entry, value, &ConfigValueContainer::tset))
+            COUT(1) << "Error: Config value \"" << entry << "\" in section \"" << section << "\" doesn't exist." << std::endl;
     }
 
Index: code/trunk/src/libraries/core/ConfigFileManager.h
===================================================================
--- code/trunk/src/libraries/core/ConfigFileManager.h	(revision 7278)
+++ code/trunk/src/libraries/core/ConfigFileManager.h	(revision 7284)
@@ -331,6 +331,6 @@
             void clean(bool bCleanComments = false); // tolua_export
 
-            bool config(const std::string& section, const std::string& entry, const std::string& value); // tolua_export
-            bool tconfig(const std::string& section, const std::string& entry, const std::string& value); // tolua_export
+            void config(const std::string& section, const std::string& entry, const std::string& value); // tolua_export
+            void tconfig(const std::string& section, const std::string& entry, const std::string& value); // tolua_export
             std::string getConfig(const std::string& section, const std::string& entry); // tolua_export
 
Index: code/trunk/src/libraries/core/ConfigValueContainer.cc
===================================================================
--- code/trunk/src/libraries/core/ConfigValueContainer.cc	(revision 7278)
+++ code/trunk/src/libraries/core/ConfigValueContainer.cc	(revision 7284)
@@ -302,5 +302,5 @@
     bool ConfigValueContainer::callFunctionWithIndex(bool (ConfigValueContainer::* function) (unsigned int, const MultiType&), const std::string& input)
     {
-        SubString token(input, " ", SubString::WhiteSpaces, true, '\\', false, '"', false, '(', ')', false, '\0');
+        SubString token(input, " ", SubString::WhiteSpaces, true, '\\', false, '"', false, '\0', '\0', false, '\0');
         int index = -1;
         bool success = false;
Index: code/trunk/src/libraries/core/Core.cc
===================================================================
--- code/trunk/src/libraries/core/Core.cc	(revision 7278)
+++ code/trunk/src/libraries/core/Core.cc	(revision 7284)
@@ -52,7 +52,7 @@
 #include "util/Exception.h"
 #include "util/Scope.h"
+#include "util/ScopedSingletonManager.h"
 #include "util/SignalHandler.h"
 #include "PathConfig.h"
-#include "CommandExecutor.h"
 #include "CommandLineParser.h"
 #include "ConfigFileManager.h"
@@ -65,9 +65,9 @@
 #include "Identifier.h"
 #include "Language.h"
-#include "IOConsole.h"
 #include "LuaState.h"
-#include "ScopedSingletonManager.h"
-#include "TclBind.h"
-#include "TclThreadManager.h"
+#include "command/ConsoleCommand.h"
+#include "command/IOConsole.h"
+#include "command/TclBind.h"
+#include "command/TclThreadManager.h"
 #include "input/InputManager.h"
 
@@ -88,5 +88,5 @@
         : identifierDestroyer_(Identifier::destroyAllIdentifiers)
         // Cleanup guard for external console commands that don't belong to an Identifier
-        , consoleCommandDestroyer_(CommandExecutor::destroyExternalCommands)
+        , consoleCommandDestroyer_(ConsoleCommand::destroyAll)
         , bGraphicsLoaded_(false)
         , bStartIOConsole_(true)
Index: code/trunk/src/libraries/core/CorePrereqs.h
===================================================================
--- code/trunk/src/libraries/core/CorePrereqs.h	(revision 7278)
+++ code/trunk/src/libraries/core/CorePrereqs.h	(revision 7284)
@@ -119,6 +119,4 @@
     T orxonox_cast(U*);
 
-    class ArgumentCompleter;
-    class ArgumentCompletionListElement;
     class BaseObject;
     template <class T>
@@ -130,5 +128,4 @@
     class ClassTreeMaskNode;
     class ClassTreeMaskObjectIterator;
-    class CommandEvaluation;
     class CommandLineParser;
     class CommandLineArgument;
@@ -140,5 +137,4 @@
     class ConfigFileSection;
     class ConfigValueContainer;
-    class ConsoleCommand;
     class Core;
     class DynLib;
@@ -146,13 +142,5 @@
     struct Event;
     class EventState;
-    class Executor;
-    template <class T>
-    class ExecutorMember;
-    class ExecutorStatic;
     class Factory;
-    class Functor;
-    template <class T>
-    class FunctorMember;
-    class FunctorStatic;
     class Game;
     class GameState;
@@ -162,9 +150,8 @@
     class GUIManager;
     class Identifier;
-    class IOConsole;
-    class IRC;
     template <class T>
     class Iterator;
     class Language;
+    class LuaFunctor;
     class LuaState;
     class MemoryArchive;
@@ -187,15 +174,8 @@
     struct ResourceInfo;
     class SettingsConfigFile;
-    class Shell;
-    class ShellListener;
     template <class T>
     class SmartPtr;
     template <class T>
     class SubclassIdentifier;
-    class TclBind;
-    struct TclInterpreterBundle;
-    template <class T>
-    class TclThreadList;
-    class TclThreadManager;
     class Template;
     class Thread;
@@ -212,4 +192,29 @@
     class XMLPortObjectContainer;
     class XMLPortParamContainer;
+
+    // Command
+    class ArgumentCompleter;
+    class ArgumentCompletionListElement;
+    class CommandEvaluation;
+    class ConsoleCommand;
+    class Executor;
+    template <class T>
+    class ExecutorMember;
+    class ExecutorStatic;
+    class Functor;
+    template <class O>
+    class FunctorMember;
+    typedef FunctorMember<void> FunctorStatic;
+    template <class F, class O>
+    class FunctorPointer;
+    class IOConsole;
+    class IRC;
+    class Shell;
+    class ShellListener;
+    class TclBind;
+    struct TclInterpreterBundle;
+    template <class T>
+    class TclThreadList;
+    class TclThreadManager;
 
     // Input
@@ -238,4 +243,7 @@
 }
 
+#include "command/FunctorPtr.h"
+#include "command/ExecutorPtr.h"
+
 // CppTcl
 namespace Tcl
Index: code/trunk/src/libraries/core/Event.cc
===================================================================
--- code/trunk/src/libraries/core/Event.cc	(revision 7278)
+++ code/trunk/src/libraries/core/Event.cc	(revision 7284)
@@ -34,13 +34,4 @@
 namespace orxonox
 {
-    /**
-        @brief Destructor: Deletes the functor of the event state.
-    */
-    EventState::~EventState()
-    {
-        if (this->statefunction_)
-            delete this->statefunction_;
-    }
-
     /**
         @brief Processes an event (calls the set-function if the necessary conditions are met).
Index: code/trunk/src/libraries/core/Event.h
===================================================================
--- code/trunk/src/libraries/core/Event.h	(revision 7278)
+++ code/trunk/src/libraries/core/Event.h	(revision 7284)
@@ -67,10 +67,9 @@
     {
         public:
-            EventState(Functor* statefunction, Identifier* subclass, bool bSink = false) : bProcessingEvent_(false), activeEvents_(0), statefunction_(statefunction), subclass_(subclass), bSink_(bSink) {}
-            virtual ~EventState();
+            EventState(const FunctorPtr& statefunction, Identifier* subclass, bool bSink = false) : bProcessingEvent_(false), activeEvents_(0), statefunction_(statefunction), subclass_(subclass), bSink_(bSink) {}
 
             void process(const Event& event, BaseObject* object);
 
-            Functor* getFunctor() const
+            const FunctorPtr& getFunctor() const
                 { return this->statefunction_; }
 
@@ -78,5 +77,5 @@
             bool        bProcessingEvent_;  //!< This becomes true while the container processes an event (used to prevent loops)
             int         activeEvents_;      //!< The number of events which affect this state and are currently active
-            Functor*    statefunction_;     //!< A functor to set the state
+            FunctorPtr  statefunction_;     //!< A functor to set the state
             Identifier* subclass_;          //!< Originators must be an instance of this class (usually BaseObject, but some statefunctions allow a second argument with an originator of a specific class)
             bool        bSink_;             //!< Determines whether the EventState acts as an EventSink forwarding any Event (even if the state didn't change) or in the normal manner, only processing Events that change the state.
Index: code/trunk/src/libraries/core/EventIncludes.h
===================================================================
--- code/trunk/src/libraries/core/EventIncludes.h	(revision 7278)
+++ code/trunk/src/libraries/core/EventIncludes.h	(revision 7284)
@@ -31,6 +31,6 @@
 
 #include "CorePrereqs.h"
-#include "Executor.h"
 #include "XMLPort.h"
+#include "command/Executor.h"
 
 /**
@@ -76,6 +76,8 @@
 
 #define XMLPortEventStateIntern(name, classname, statename, xmlelement, mode) \
-    static orxonox::ExecutorMember<classname>* xmlsetfunctor##name = (orxonox::ExecutorMember<classname>*)&orxonox::createExecutor(orxonox::createFunctor(&classname::addEventSource), std::string( #classname ) + "::" + "addEventSource" + '(' + statename + ')')->setDefaultValue(1, statename); \
-    static orxonox::ExecutorMember<classname>* xmlgetfunctor##name = (orxonox::ExecutorMember<classname>*)&orxonox::createExecutor(orxonox::createFunctor(&classname::getEventSource), std::string( #classname ) + "::" + "getEventSource" + '(' + statename + ')')->setDefaultValue(1, statename); \
+    static orxonox::ExecutorMemberPtr<classname> xmlsetfunctor##name = orxonox::createExecutor(orxonox::createFunctor(&classname::addEventSource), std::string( #classname ) + "::" + "addEventSource" + '(' + statename + ')').cast<orxonox::ExecutorMember<classname> >(); \
+    static orxonox::ExecutorMemberPtr<classname> xmlgetfunctor##name = orxonox::createExecutor(orxonox::createFunctor(&classname::getEventSource), std::string( #classname ) + "::" + "getEventSource" + '(' + statename + ')').cast<orxonox::ExecutorMember<classname> >(); \
+    xmlsetfunctor##name->setDefaultValue(1, statename); \
+    xmlgetfunctor##name->setDefaultValue(1, statename); \
     XMLPortObjectGeneric(xmlport##name, classname, orxonox::BaseObject, statename, xmlsetfunctor##name, xmlgetfunctor##name, xmlelement, mode, false, true)
 
Index: code/trunk/src/libraries/core/GUIManager.cc
===================================================================
--- code/trunk/src/libraries/core/GUIManager.cc	(revision 7278)
+++ code/trunk/src/libraries/core/GUIManager.cc	(revision 7284)
@@ -57,5 +57,4 @@
 #include "util/Exception.h"
 #include "util/OrxAssert.h"
-#include "ConsoleCommand.h"
 #include "Core.h"
 #include "GraphicsManager.h"
@@ -63,4 +62,5 @@
 #include "PathConfig.h"
 #include "Resource.h"
+#include "command/ConsoleCommand.h"
 #include "input/InputManager.h"
 #include "input/InputState.h"
@@ -71,5 +71,5 @@
     static void key_esc()
         { GUIManager::getInstance().keyESC(); }
-    SetConsoleCommandShortcutExternAlias(key_esc, "keyESC");
+    SetConsoleCommand("keyESC", &key_esc);
 
     class CEGUILogger : public CEGUI::DefaultLogger
@@ -99,6 +99,6 @@
     GUIManager* GUIManager::singletonPtr_s = 0;
 
-    SetConsoleCommandShortcut(GUIManager, showGUI).accessLevel(AccessLevel::User).defaultValue(1, false).defaultValue(2, true);
-    SetConsoleCommandShortcut(GUIManager, hideGUI).accessLevel(AccessLevel::User);
+    SetConsoleCommand("showGUI", &GUIManager::showGUI).defaultValue(1, false).defaultValue(2, true);
+    SetConsoleCommand("hideGUI", &GUIManager::hideGUI);
 
     /**
Index: code/trunk/src/libraries/core/Game.cc
===================================================================
--- code/trunk/src/libraries/core/Game.cc	(revision 7278)
+++ code/trunk/src/libraries/core/Game.cc	(revision 7284)
@@ -45,5 +45,4 @@
 #include "util/SubString.h"
 #include "CommandLineParser.h"
-#include "ConsoleCommand.h"
 #include "Core.h"
 #include "CoreIncludes.h"
@@ -52,4 +51,5 @@
 #include "GameState.h"
 #include "GUIManager.h"
+#include "command/ConsoleCommand.h"
 
 namespace orxonox
@@ -57,11 +57,11 @@
     static void stop_game()
         { Game::getInstance().stop(); }
-    SetConsoleCommandShortcutExternAlias(stop_game, "exit");
+    SetConsoleCommand("exit", &stop_game);
     static void printFPS()
         { COUT(0) << Game::getInstance().getAvgFPS() << std::endl; }
-    SetConsoleCommandShortcutExternAlias(printFPS, "printFPS");
+    SetConsoleCommand("printFPS", &printFPS);
     static void printTickTime()
         { COUT(0) << Game::getInstance().getAvgTickTime() << std::endl; }
-    SetConsoleCommandShortcutExternAlias(printTickTime, "printTickTime");
+    SetConsoleCommand("printTickTime", &printTickTime);
 
     std::map<std::string, GameStateInfo> Game::gameStateDeclarations_s;
Index: code/trunk/src/libraries/core/GraphicsManager.cc
===================================================================
--- code/trunk/src/libraries/core/GraphicsManager.cc	(revision 7278)
+++ code/trunk/src/libraries/core/GraphicsManager.cc	(revision 7284)
@@ -52,5 +52,4 @@
 #include "util/StringUtils.h"
 #include "util/SubString.h"
-#include "ConsoleCommand.h"
 #include "ConfigValueIncludes.h"
 #include "CoreIncludes.h"
@@ -62,7 +61,11 @@
 #include "WindowEventListener.h"
 #include "XMLFile.h"
+#include "command/ConsoleCommand.h"
 
 namespace orxonox
 {
+    static const std::string __CC_printScreen_name = "printScreen";
+    DeclareConsoleCommand(__CC_printScreen_name, &prototype::void__void);
+
     class OgreWindowEventListener : public Ogre::WindowEventListener
     {
@@ -131,5 +134,5 @@
 
         Ogre::WindowEventUtilities::removeWindowEventListener(renderWindow_, ogreWindowEventListener_.get());
-        // TODO: Destroy the console command
+        ModifyConsoleCommand(__CC_printScreen_name).resetFunction();
 
         // Undeclare the resources
@@ -290,5 +293,5 @@
         boost::filesystem::path folder(ogrePluginsDirectory_);
         // Do some SubString magic to get the comma separated list of plugins
-        SubString plugins(ogrePlugins_, ",", " ", false, '\\', false, '"', false, '(', ')', false, '\0');
+        SubString plugins(ogrePlugins_, ",", " ", false, '\\', false, '"', false, '{', '}', false, '\0');
         // Use backslash paths on Windows! file_string() already does that though.
         for (unsigned int i = 0; i < plugins.size(); ++i)
@@ -321,6 +324,5 @@
 
         // add console commands
-        ccPrintScreen_ = createConsoleCommand(createFunctor(&GraphicsManager::printScreen, this), "printScreen");
-        CommandExecutor::addConsoleCommandShortcut(ccPrintScreen_);
+        ModifyConsoleCommand(__CC_printScreen_name).setFunction(&GraphicsManager::printScreen, this);
     }
 
Index: code/trunk/src/libraries/core/GraphicsManager.h
===================================================================
--- code/trunk/src/libraries/core/GraphicsManager.h	(revision 7278)
+++ code/trunk/src/libraries/core/GraphicsManager.h	(revision 7284)
@@ -114,7 +114,4 @@
         int                 ogreLogLevelCritical_;     //!< Corresponding Orxonox debug level for LL_CRITICAL
 
-        // console commands
-        ConsoleCommand*     ccPrintScreen_;
-
         static GraphicsManager* singletonPtr_s;        //!< Pointer to the Singleton
     };
Index: code/trunk/src/libraries/core/Identifier.cc
===================================================================
--- code/trunk/src/libraries/core/Identifier.cc	(revision 7278)
+++ code/trunk/src/libraries/core/Identifier.cc	(revision 7284)
@@ -38,5 +38,4 @@
 #include "util/StringUtils.h"
 #include "ConfigValueContainer.h"
-#include "ConsoleCommand.h"
 #include "ClassFactory.h"
 #include "XMLPort.h"
@@ -64,5 +63,4 @@
 
         this->bHasConfigValues_ = false;
-        this->bHasConsoleCommands_ = false;
 
         // Default network ID is the class ID
@@ -80,6 +78,4 @@
             delete this->factory_;
 
-        for (std::map<std::string, ConsoleCommand*>::iterator it = this->consoleCommands_.begin(); it != this->consoleCommands_.end(); ++it)
-            delete (it->second);
         for (std::map<std::string, ConfigValueContainer*>::iterator it = this->configValues_.begin(); it != this->configValues_.end(); ++it)
             delete (it->second);
@@ -433,57 +429,4 @@
 
     /**
-        @brief Adds a new console command of this class.
-        @param executor The executor of the command
-        @param bCreateShortcut If this is true a shortcut gets created so you don't have to add the classname to access this command
-        @return The executor of the command
-    */
-    ConsoleCommand& Identifier::addConsoleCommand(ConsoleCommand* command, bool bCreateShortcut)
-    {
-        std::map<std::string, ConsoleCommand*>::const_iterator it = this->consoleCommands_.find(command->getName());
-        if (it != this->consoleCommands_.end())
-        {
-            COUT(2) << "Warning: Overwriting console-command with name " << command->getName() << " in class " << this->getName() << '.' << std::endl;
-            delete (it->second);
-        }
-
-        this->bHasConsoleCommands_ = true;
-        this->consoleCommands_[command->getName()] = command;
-        this->consoleCommands_LC_[getLowercase(command->getName())] = command;
-
-        if (bCreateShortcut)
-            CommandExecutor::addConsoleCommandShortcut(command);
-
-        return (*command);
-    }
-
-    /**
-        @brief Returns the executor of a console command with given name.
-        @brief name The name of the requested console command
-        @return The executor of the requested console command
-    */
-    ConsoleCommand* Identifier::getConsoleCommand(const std::string& name) const
-    {
-        std::map<std::string, ConsoleCommand*>::const_iterator it = this->consoleCommands_.find(name);
-        if (it != this->consoleCommands_.end())
-            return it->second;
-        else
-            return 0;
-    }
-
-    /**
-        @brief Returns the executor of a console command with given name in lowercase.
-        @brief name The name of the requested console command in lowercae
-        @return The executor of the requested console command
-    */
-    ConsoleCommand* Identifier::getLowercaseConsoleCommand(const std::string& name) const
-    {
-        std::map<std::string, ConsoleCommand*>::const_iterator it = this->consoleCommands_LC_.find(name);
-        if (it != this->consoleCommands_LC_.end())
-            return it->second;
-        else
-            return 0;
-    }
-
-    /**
         @brief Returns a XMLPortParamContainer that loads a parameter of this class.
         @param paramname The name of the parameter
